---

traefik_docker_repository: traefik
traefik_docker_tag: v2.9.10

traefik_default_static_config:
  api:
    dashboard: true
  accessLog: {}

  certificatesResolvers:

  entryPoints:
    http:
      address: ":80"
      http:
        redirections:
          entryPoint:
            to: https
            scheme: https

    https:
      address: ":443"

  global:
    checknewversion: false
    sendanonymoususage: false

  providers:
    docker:
      endpoint: "unix:///var/run/docker.sock"
      exposedByDefault: false
      network: reverse_proxy
      watch: true

    file:
      filename: /etc/traefik/config.yml
      watch: true

traefik_static_config: {}
traefik_static_config_computed: "{{ traefik_default_static_config | combine(traefik_static_config, recursive=True) }}"


traefik_default_dynamic_config:
  http:
    middlewares:
      default:
        chain:
          middlewares:
            - default-security-headers
            - error-pages
            - gzip

      default-without-error-pages:
        chain:
          middlewares:
            - default-security-headers
            - gzip

      default-security-headers:
        headers:
          browserXssFilter: true
          contentTypeNosniff: true
          forceSTSHeader: true
          frameDeny: true
          customFrameOptionsValue: SAMEORIGIN
          referrerPolicy: strict-origin-when-cross-origin
          sslRedirect: true
          stsIncludeSubdomains: true
          stsPreload: true
          stsSeconds: 63072000

      error-pages:
        errors:
          service: error-pages
          status: "400-599"
          query: "/{status}.html"

      gzip:
        compress: {}

    services:
      error-pages:
        loadBalancer:
          servers:
            - url: http://traefik_errorpages:8080

  tls:
    options:
      modern:
        minVersion: VersionTLS13
        sniStrict: true

      intermediate:
        minVersion: VersionTLS12
        cipherSuites:
          - TLS_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256
          - TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256
          - TLS_ECDHE_ECDSA_WITH_AES_256_GCM_SHA384
          - TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384
          - TLS_ECDHE_ECDSA_WITH_CHACHA20_POLY1305
          - TLS_ECDHE_RSA_WITH_CHACHA20_POLY1305
        sniStrict: true

      ipxe:
        minVersion: VersionTLS12
        cipherSuites:
          - TLS_RSA_WITH_AES_256_CBC_SHA
        sniStrict: true

traefik_dynamic_config: {}
traefik_dynamic_config_computed: "{{ traefik_default_dynamic_config | combine(traefik_dynamic_config, recursive=True) }}"


errorpages_docker_repository: ghcr.io/tarampampam/error-pages
errorpages_docker_tag: 2.21.0

errorpages_config:
  templates:
    - path: ./prologin.html

  formats:
    json:
      content: !unsafe |
        {
          "error": true,
          "code": {{ code | json }},
          "message": {{ message | json }},
          "description": {{ description | json }}{{ if show_details }},
          "details": {
            "host": {{ host | json }},
            "original_uri": {{ original_uri | json }},
            "forwarded_for": {{ forwarded_for | json }},
            "namespace": {{ namespace | json }},
            "ingress_name": {{ ingress_name | json }},
            "service_name": {{ service_name | json }},
            "service_port": {{ service_port | json }},
            "request_id": {{ request_id | json }},
            "timestamp": {{ now.Unix }}
          }{{ end }}
        }
    xml:
      content: !unsafe |
        <?xml version="1.0" encoding="utf-8"?>
        <error>
          <code>{{ code }}</code>
          <message>{{ message }}</message>
          <description>{{ description }}</description>{{ if show_details }}
          <details>
            <host>{{ host }}</host>
            <originalURI>{{ original_uri }}</originalURI>
            <forwardedFor>{{ forwarded_for }}</forwardedFor>
            <namespace>{{ namespace }}</namespace>
            <ingressName>{{ ingress_name }}</ingressName>
            <serviceName>{{ service_name }}</serviceName>
            <servicePort>{{ service_port }}</servicePort>
            <requestID>{{ request_id }}</requestID>
            <timestamp>{{ now.Unix }}</timestamp>
          </details>{{ end }}
        </error>
  pages:
    400:
      message: Bad Request
      description: The server did not understand the request

    401:
      message: Unauthorized
      description: The requested page needs a username and a password

    403:
      message: Forbidden
      description: Access is forbidden to the requested page

    404:
      message: Not Found
      description: The server can not find the requested page

    405:
      message: Method Not Allowed
      description: The method specified in the request is not allowed

    407:
      message: Proxy Authentication Required
      description: You must authenticate with a proxy server before this request can be served

    408:
      message: Request Timeout
      description: The request took longer than the server was prepared to wait

    409:
      message: Conflict
      description: The request could not be completed because of a conflict

    410:
      message: Gone
      description: The requested page is no longer available

    411:
      message: Length Required
      description: The "Content-Length" is not defined. The server will not accept the request without it

    412:
      message: Precondition Failed
      description: The pre condition given in the request evaluated to false by the server

    413:
      message: Payload Too Large
      description: The server will not accept the request, because the request entity is too large

    416:
      message: Requested Range Not Satisfiable
      description: The requested byte range is not available and is out of bounds

    418:
      message: I'm a teapot
      description: Attempt to brew coffee with a teapot is not supported

    429:
      message: Too Many Requests
      description: Too many requests in a given amount of time

    500:
      message: Internal Server Error
      description: The server met an unexpected condition

    502:
      message: Bad Gateway
      description: The server received an invalid response from the upstream server

    503:
      message: Service Unavailable
      description: The server is temporarily overloading or down

    504:
      message: Gateway Timeout
      description: The gateway has timed out

    505:
      message: HTTP Version Not Supported
      description: The server does not support the "http protocol" version
